/* lib.c - Some libc function wrappers.
   Copyright (C) 2004 Neal H. Walfield
   Written by Neal H. Walfield <neal@cs.uml.edu>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <error.h>
#include <errno.h>

#include "lib.h"

void *
xmalloc (size_t size)
{
  void *ptr = malloc (size);
  if (! ptr)
    error (1, errno, __FUNCTION__);
  return ptr;
}

void *
xrealloc (void *ptr, size_t newsize)
{
  void *nptr = realloc (ptr, newsize);
  if (! nptr)
    error (1, errno, __FUNCTION__);
  return nptr;
}

void *
xcalloc (size_t count, size_t eltsize)
{
  void *ptr = calloc (count, eltsize);
  if (! ptr)
    error (1, errno, __FUNCTION__);
  return ptr;
}

char *
xstrdup (const char *string)
{
  char *s = strdup (string);
  if (! s)
    error (1, errno, __FUNCTION__);
  return s;
}
